#!/usr/bin/python
from Xlib import X,XK,display
import sys,os
import gobject

class HotKey:
    def __init__(self,keystr,action,*args):
        self.action=action
        self.args=args

        self.disp = display.Display()
        self.root = self.disp.screen().root

        self.key,self.mask=self.parse_keystr(keystr)
        self.root.change_attributes(event_mask = X.KeyPressMask)
        self.root.grab_key(self.key, self.mask,0,X.GrabModeAsync, X.GrabModeAsync)
        gobject.timeout_add(250,self.next_event)
    def next_event(self):
        try:
            while self.disp.pending_events():
                xev=self.root.display.next_event() 
                if xev and xev.type==X.KeyPress and xev.detail==self.key:
                    self.action(*self.args)
                    break
            return True
        except:
            self.disp.ungrab_keyboard(X.CurrentTime)
            self.disp.flush()
            self.root.ungrab_key(X.AnyKey,X.AnyModifier)
    def parse_keystr(self,keystr):
        keystr=keystr.replace('<','').lower().split('>')
        KEY=dict([(key.lower()[3:],self.disp.keysym_to_keycode(val)) for key,val in XK.__dict__.items() if key.startswith('XK_')])[keystr.pop()]
        if not keystr:
            MASK=X.AnyModifier
        else:
            MASK=0
            for val in keystr:
                MASK=MASK | getattr(X,'%sMask'%val.capitalize())
        return (KEY,MASK)






