# -*- coding: utf-8 -*-

class Conf(object):
    def _guess_command(self):
        from os import popen
        #[f for f in chain(*tuple(map(os.listdir,os.environ['PATH'].split(':'))))
        #if 'term' in f or 'onsole' in f or f.endswith('vt')]
        for t in ['xfce4-terminal --disable-server --hide-menubar --hide-toolbars --title=qcon','gnome-terminal --disable-factory --hide-menubar --title=qcon','xterm','urxvt','rxvt','konsole --noframe --nomenubar --caption=qcon']:
            if popen('which %s'%t.split()[0]).read():
                return t
        return ''
    def __init__(self,rcpath):
        from os.path import expanduser
        self.COMMAND=''
        self.POSITION='top-center'
        self.WIDTH=100
        self.HEIGHT=50
        self.OFFSET_X=0
        self.OFFSET_Y=0
        self.KEY=''
        self.RESPAWN=False
        self.BORDER=True
        self.START_HIDDEN=False
        self.FIND_WINDOW_TIMEOUT=15
        self._rcpath=expanduser(rcpath)
        self._read()
    def _read(self):
        import string
        from os.path import exists
        self._tpl=''
        keys=[k for k in self.__dict__.keys() if not k.startswith('_')]
        if exists(self._rcpath):
            self._exists=True
            for line in file(self._rcpath):
                line=line.replace('%','%%')
                line2=line.split('#',1)[0]
                if '=' in line2:
                    k,v=[v.strip(string.whitespace+'"\'')
                            for v in line2.split('=',1)]
                    if k in keys:
                        keys.remove(k)
                        line=line.replace(v,'%('+k+')s')
                        opttype=type(getattr(self,k))
                        if opttype is bool:
                            v=v.lower() not in ('false','off','0','no','n')
                        else:
                            v=opttype(v)
                        setattr(self,k,v)
                self._tpl+=line
        else:
            self._exists=False
            self.COMMAND=self._guess_command()
        for k in keys:
            self._tpl+=k+' = %('+k+')s\n'
    def _write(self):
        data=self._tpl % self.__dict__
        open(self._rcpath,'w').write( data )
    def _geom(self,scrobj):
        w = int(scrobj.get_width()/100.0*float(self.WIDTH))
        h = int(scrobj.get_height()/100.0*float(self.HEIGHT))
        if 'right' in self.POSITION.lower(): x = scrobj.get_width()-w-self.OFFSET_X
        elif 'left' in self.POSITION.lower(): x = self.OFFSET_X
        else: x = scrobj.get_width()/2-(w/2)
        if 'bottom' in self.POSITION.lower(): y = scrobj.get_height()-h-self.OFFSET_Y
        elif 'top' in self.POSITION.lower(): y = self.OFFSET_Y
        else: y = scrobj.get_height()/2-(h/2)
        return ((x,y),(w,h))
    def _getpath(self,filename='',path2=''):
        import os
        locations=[os.path.join(os.path.dirname(__file__),'..','share',path2 or 'qcon','qcon'),
                os.path.join(os.path.dirname(__file__),'..','share',path2 or 'qcon'),
                os.path.join('/usr/share',path2,'qcon'),
                os.path.join('/usr/local/share',path2,'qcon'),]
        try:
            prefix=(path for path in locations if os.path.exists(path)).next()
        except StopIteration:
            raise IOError("could't guest data path")
        path=os.path.join(prefix,filename)
        if not os.path.exists(path):
            raise IOError("could't find %s in %s"%(filename,prefix))
        return path
        




