#!/usr/bin/env python
# -*- coding: UTF8 -*-

# Python module settings.py
# Autogenerated from settings_glade.glade
# Generated on Sat Jan  5 20:41:49 2008

# Warning: Do not modify any context comment such as #--
# They are required to keep user's code

import os,sys,signal

import gtk

from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain

import qcon

try:
    from Xlib.display import Display
    from Xlib import X,XK
    disp=Display()
    root=disp.screen().root
    MODIFIERS=[]
    for mod in disp.get_modifier_mapping():
        for keyval in mod:
            MODIFIERS.append(keyval)
except:
    Display=X=XK=None

from __init__ import __title__ as app_name,__version__ as app_version

locale_dir = ""
bindtextdomain(app_name, locale_dir)

from conf import Conf
conf=Conf('~/.qconrc')



def key_pressed(widget,event,obj):
    keyval=gtk.gdk.keyval_name(event.keyval)
    for modmask in event.state.value_nicks:
        keyval='<%s>%s'%(modmask.replace('-mask','').capitalize(),keyval)
    #if keyval[-2:] not in ('_L','_R') and keyval[:-5]!='_Lock':
    if event.hardware_keycode not in MODIFIERS and keyval[-2:] not in ('_L','_R') and not keyval.endswith('_Lock') and 'ISO_' not in keyval:
        obj.keyname=keyval
        obj.keyval=event.hardware_keycode
    else:
        obj.keyname=None
    return

def key_released(widget,event,obj):
    if obj.keyname and obj.keyname not in ('Escape','Tab'):
        #root.grab_key(obj.keyval, x.anymodifier,root,x.grabmodeasync, x.grabmodeasync)
        print obj.keyval
        obj.set_text(obj.keyname)
        widget.destroy()
    obj.keyname=None
    
def ask_key(target):
    d=gtk.Dialog('Press a key') 
    d.vbox.pack_start(gtk.Label('Press a key'))
    d.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL)
    d.target=target
    d.connect('response',lambda obj,resp:obj.destroy())
    d.connect('key_press_event',key_pressed,target)
    d.connect('key_release_event',key_released,target)
    d.connect('focus_out_event',lambda *args:gtk.main_quit())
    d.show_all()


class Settings(SimpleGladeApp):

    def __init__(self, path="settings.glade",
                 root="settings",
                 domain=app_name, **kwargs):
        path=conf._getpath('settings.glade')
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    #-- Settings.new {
    def new(self):
        self.cmdline.prepend_text(str(conf.COMMAND))
        self.cmdline.set_active(0)
        if 'left' in conf.POSITION.lower(): self.horiz.set_active(0)
        elif 'right' in conf.POSITION.lower(): self.horiz.set_active(2)
        else: self.horiz.set_active(1)
        if 'top' in conf.POSITION.lower(): self.vert.set_active(0)
        elif 'bottom' in conf.POSITION.lower(): self.vert.set_active(2)
        else: self.vert.set_active(1)
        #self.posw.set_range(0,gtk.gdk.screen_width())
        #self.posx.set_range(-gtk.gdk.screen_width(),gtk.gdk.screen_width())
        #self.posh.set_range(0,gtk.gdk.screen_height())
        #self.posy.set_range(0,gtk.gdk.screen_height())
        #self.posx.set_value(int(LEFT.replace('%','')))
        #self.posy.set_value(int(TOP.replace('%','')))
        self.posw.set_value(conf.WIDTH)
        self.posh.set_value(conf.HEIGHT)
        self.borders.set_active(conf.BORDER)
        self.respawn.set_active(conf.RESPAWN)
        self.starthidden.set_active(conf.START_HIDDEN)
        self.hotkey.set_text(str(conf.KEY or ''))
        self.nokey.hotkey=self.hotkey
        if not X:
            self.keyframe.set_sensitive(False)
            self.hotkey.set_text('Python-xlib required')
            self.hotkeybox.remove(self.nokey)

    #-- Settings.new }

    #-- Settings custom methods {
    #   Write your own methods here
    #-- Settings custom methods }

    #-- Settings.on_response {

    def on_response(self, widget, resp):
        if resp == gtk.RESPONSE_OK:
            conf.COMMAND = self.cmdline.get_active_text()
            conf.POSITION = '%s-%s'%(self.vert.get_active_text(),self.horiz.get_active_text())
            conf.WIDTH = int(self.posw.get_value())
            conf.HEIGHT = int(self.posh.get_value())
            conf.BORDER = self.borders.get_active()
            conf.RESPAWN = self.respawn.get_active()
            conf.START_HIDDEN = self.starthidden.get_active()
            if X:
                conf.KEY = self.hotkey.get_text()
            conf._write()
            try:
                os.kill(int(open(os.path.expanduser('~/.qcon.pid')).read()),signal.SIGHUP)
            except:
                pass
        self.settings.destroy()
        gtk.main_quit()
    #-- Settings.on_response }
    #-- Settings.on_hotkey_focus {
    def on_hotkey_focus(self, obj, *args):
        ask_key(obj)
    #-- Settings.on_hotkey_focus }
    #-- Settings.on_nokey {
    def on_nokey(self, widget, *args):
        widget.hotkey.set_text('')
    #-- Settings.on_nokey }

#-- main {

def main():
    settings = Settings()

    settings.run()

if __name__ == "__main__":
    main()

#-- main }
